//==============================================================================
/*! \file     test_app.cpp
    \brief    A test application
    \ingroup  
    \author   Pierluigi Vicinanza
*/
//==============================================================================

#include "test_app.hpp"

#include <Wt/WContainerWidget>
#include <Wt/WVBoxLayout>
#include <Wt/WLabel>

using namespace Wt;

/*------------------------------------------------------------------------------
  LogPage
------------------------------------------------------------------------------*/

class LogPage : public Wt::WContainerWidget
{
public:
    LogPage(Wt::WContainerWidget * parent = NULL)
        : WContainerWidget(parent)
    {
        WVBoxLayout * textLayout = new WVBoxLayout();

        WContainerWidget * textWidget = new WContainerWidget();
        textWidget->setLayout(textLayout);
        textWidget->setOverflow(WContainerWidget::OverflowAuto);

        WVBoxLayout * mainLayout = new WVBoxLayout();
        mainLayout->addWidget(textWidget);

        setLayout(mainLayout);

        for (int i = 0; i < 50; ++i)
        {
            WLabel * line = new WLabel("[22 Sep 2014 16:16:07 GMT Daylight Time]"
                                       "Lorem ipsum dolor sit amet, consectetur adipiscing elit."
                                       "Pellentesque porta placerat massa, vitae laoreet justo vulputate nec.");
            textLayout->addWidget(line);
        }
    }
};

/*------------------------------------------------------------------------------
  MainWidget
------------------------------------------------------------------------------*/

class MainWidget : public WVBoxLayout
{
public:
    MainWidget::MainWidget(WWidget * parent = NULL)
        : WVBoxLayout(parent)
    {
        WLabel * title = new WLabel("Log");
        addWidget(title, 0, AlignCenter);

        LogPage * logPage = new LogPage();
        addWidget(logPage, 1);
    }
};

/*------------------------------------------------------------------------------
  TestApplication
------------------------------------------------------------------------------*/

void TestApplication::initialize()
{
    MainWidget * mainWidget = new MainWidget();
    root()->setLayout(mainWidget);
}
